/*
 * RCS info: $Source:
 *           $Revision: $
 *           $Date:$
 *           $Author:$
 *           $Log:$
 * Copyright (c) 2012 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFfpferep.h
 * Tv  FrbgG[ϐ̉Zʒuo `
 *==========================================================================*/

#ifndef _DEF_FPFEREP_
#define _DEF_FPFEREP_


/*************************************************************************
 * CONSTANT VALUE
 *************************************************************************/

enum _fpferep_type{
    _FPFEREP_TYPE_VAR,
    _FPFEREP_TYPE_CONST,
    _FPFEREP_TYPE_FUNC,
    _FPFEREP_TYPE_LOGCND
};


enum _fpferep_valtype{
    _FPFEREP_VALTYPE_NON,
    _FPFEREP_VALTYPE_VOID,
    _FPFEREP_VALTYPE_BOOL,
    _FPFEREP_VALTYPE_CHAR,
    _FPFEREP_VALTYPE_SHORT,
    _FPFEREP_VALTYPE_INT,
    _FPFEREP_VALTYPE_LONG,
    _FPFEREP_VALTYPE_LONGLONG,
    _FPFEREP_VALTYPE_FLOAT,
    _FPFEREP_VALTYPE_DOUBLE,
    _FPFEREP_VALTYPE_LONGDOUBLE,
    _FPFEREP_VALTYPE_STRUCT,
};

enum _fpferep_Signed{
    _FPFEREP_SIGNED_NON,
    _FPFEREP_SIGNED,
    _FPFEREP_UNSIGNED,
};

enum _fpferep_calc_kind {
    _FPFEREP_Asgn= 1,       // 'A=B'
    _FPFEREP_Plus,          // '+A'
    _FPFEREP_Minus,         // '-A'
    _FPFEREP_Not,           // '!A'
    _FPFEREP_Mul,           // 'A * B'
    _FPFEREP_Div,           // 'A / B'
    _FPFEREP_Mod,           // 'A % B'
    _FPFEREP_Add,           // 'A + B'
    _FPFEREP_Sub,           // 'A - B'
    _FPFEREP_RightShift,    // 'A >> B'
    _FPFEREP_LeftShift,     // 'A << B'
    _FPFEREP_Les,           // 'A < B'
    _FPFEREP_LesEq,         // 'A <= B'
    _FPFEREP_Gre,           // 'A > B'
    _FPFEREP_GreEq,         // 'A >= '
    _FPFEREP_Eq,            // 'A == B'
    _FPFEREP_NotEq,         // 'A != B'
    _FPFEREP_LogAnd,        // 'A && B'
    _FPFEREP_LogOr,         // 'A || B'
    _FPFEREP_And,           // 'A & B'
    _FPFEREP_Or,            // 'A | B'
    _FPFEREP_Xor,           // 'A ^ B'
    _FPFEREP_LogCond,       // 'C?A:B '
} ;

/*************************************************************************
 * pf[^
 *************************************************************************/

// Zf[^

typedef struct __fpferep_exp_data
{
    char    *file_name;     // \[Xt@C 
    char    *func_name;     // ֐ iO[oϐNULL'j
    int     line_no;        // \[Xt@Csԍ

    short   op_code;        // ZR[h
    short   ret_type;
    short   ret_val_type;
    short   left_type;
    short   left_val_type;
    short   right_type;
    short   right_val_type;

    // rbgőƂȂl
    int     f_width;

    short   flg_set_val;
    double  ret_val;
    double  left_val;
    double  right_val;

    struct __fpferep_exp_data *pNext;
} _FPFEREP_EXP_DATA;


// ϐf[^
typedef struct __fpferep_var_unit
{
    int     var_no;         // ϐԍ
    int     grp_no;         // O[vԍ

    char    *var_name;      // ϐ
    char    *file_name;     // ϐ錾t@C
    char    *func_name;     // ϐ錾֐ (O[oϐ̂Ƃ:NULL)

    short   i_width;        // rbg
    short   f_width;        // rbg
    short   i_u_width;      // Kvrbg
    short   f_u_width;      // Kvrbg

    char    *valOfFixed;    // Œ菬ƒɃG[ƂȂl
    char    *cnst_str;      // 萔̎̒l

    _FPFEREP_EXP_DATA *exp_list;    // Z

    void    *wk_data;       // ƃf[^
} _FPFEREP_VAR_UNIT;

// ϐXg
typedef struct __fpferep_varlist
{
    _FPFEREP_VAR_UNIT *pUnit;
    struct __fpferep_varlist *pGrp;
    struct __fpferep_varlist *pNext;
} _FPFEREP_VARLIST;

//
// Z iMULADIV)
//
typedef struct __fpferep_exp_unit
{
    int     exp_no;         // ɕtϐԍie[uǗpj
    int     exp_type;       // 0:MUL 1:DIV

    int     i_u_width;      // ZʕKvrbg
    int     f_u_width;      // ZʕKvrbg

    char    *ret_name;      // Zʕϐ
    int     i_width;        // Zʐrbg
    int     f_width;        // Zʏrbg
    char    *retValOfFixed;     //

    char    *left_name;     // ϐ
    int     i_left_width;   // rbg
    int     f_left_width;   // rbg
    char    *leftValOfFixed;    //

    char    *right_name;    // Eϐ
    int     i_right_width;  // Erbg
    int     f_right_width;  // Erbg
    char    *rightValOfFixed;   //

    _FPFEREP_EXP_DATA *exp_list;    // Z

    void    *wk_data;       // ƃf[^
} _FPFEREP_EXP_UNIT;


// ZXg
typedef struct __fpferep_explist
{
    _FPFEREP_EXP_UNIT *pUnit;
    struct __fpferep_explist *pNext;
} _FPFEREP_EXPLIST;



//
// O[o֐Ńt@C
//

extern int _fpferep_var_ref(
    int var_no,
    int left_type, int left_val_type, double left_val,
    int right_type, int right_val_type, double right_val );

extern int _fpferep_var_upd(
    int var_no,
    char *file_name, char *func_name, int line_no,
    int op_code, int val_type, double val );

extern int _fpferep_exp_ref(
    int exp_no,
    int left_type, int left_val_type, double left_val,
    int right_type, int right_val_type, double right_val );

extern int _fpferep_exp_upd(
    int exp_no,
    char *file_name, char *func_name, int line_no,
    int exp_type, int val_type, double val );

extern int _fpferep_const(
    int var_no, char *pCnstStr,
    char *file_name, char *func_name, int line_no,
    int val_type, double val );


#endif // !_DEF_FPFEREP_

